--- drivers/platform/x86/acer-wmi.c.orig	2010-08-21 20:28:57.000000000 +1000
+++ drivers/platform/x86/acer-wmi.c	2010-08-21 21:35:04.000000000 +1000
@@ -24,6 +24,7 @@
 
 #include <linux/kernel.h>
 #include <linux/module.h>
+#include <linux/pci.h>
 #include <linux/init.h>
 #include <linux/types.h>
 #include <linux/dmi.h>
@@ -170,6 +171,9 @@
 /* The static interface pointer, points to the currently detected interface */
 static struct wmi_interface *interface;
 
+/* az hackery */
+static struct pci_dev *pci_device;
+
 /*
  * Embedded Controller quirks
  * Some laptops require us to directly access the EC to either enable or query
@@ -691,8 +695,11 @@
 		method_id = ACER_WMID_GET_BLUETOOTH_METHODID;
 		break;
 	case ACER_CAP_BRIGHTNESS:
-		method_id = ACER_WMID_GET_BRIGHTNESS_METHODID;
-		break;
+	   /* az hackery */
+	   ec_read(0x51,&tmp);
+	   *value=tmp;
+	   return 0;
+
 	case ACER_CAP_THREEG:
 		method_id = ACER_WMID_GET_THREEG_METHODID;
 		break;
@@ -722,8 +729,19 @@
 	case ACER_CAP_BRIGHTNESS:
 		if (value > max_brightness)
 			return AE_BAD_PARAMETER;
-		method_id = ACER_WMID_SET_BRIGHTNESS_METHODID;
-		break;
+		/* az hackery: mod the vga register */
+		if (pci_device)
+		{
+		   u8 vgaval;
+
+		   /* scale is 0..9, vga 0..255: use 21+26*X */
+		   vgaval=21+26*value;
+		   pci_write_config_byte(pci_device, 0xf4, vgaval);
+		}
+		/* az hackery: update the ec */
+		return ec_write(0x51,value);
+	
+
 	case ACER_CAP_WIRELESS:
 		if (value > 1)
 			return AE_BAD_PARAMETER;
@@ -926,6 +944,13 @@
 	struct backlight_properties props;
 	struct backlight_device *bd;
 
+	/* az hackery: find vga device */
+	pci_device = pci_get_device(PCI_VENDOR_ID_INTEL, 0x8108, NULL); /* poulsbo/gma500 */
+	if (!pci_device)
+	{
+	   printk(ACER_NOTICE "could not find matching VGA device\n");
+	}
+
 	memset(&props, 0, sizeof(struct backlight_properties));
 	props.max_brightness = max_brightness;
 	bd = backlight_device_register("acer-wmi", dev, NULL, &acer_bl_ops,
@@ -947,6 +972,10 @@
 static void acer_backlight_exit(void)
 {
 	backlight_device_unregister(acer_backlight_device);
+
+	/* az hackery: get rid of pci device */
+	if (pci_device) 
+	   pci_dev_put(pci_device);
 }
 
 /*
